package com.sun.org.apache.xml.internal.security.utils;

import org.w3c.dom.NamedNodeMap;
import org.w3c.dom.Attr;
import org.w3c.dom.Element;
import java.util.Iterator;
import java.util.HashMap;
import org.w3c.dom.Node;
import java.util.Map;
import javax.xml.namespace.NamespaceContext;

public class DOMNamespaceContext implements NamespaceContext
{
    private Map<String, String> namespaceMap;
    
    public DOMNamespaceContext(Node node) {
        this.namespaceMap = new HashMap();
        this.addNamespaces(node);
    }
    
    @Override
    public String getNamespaceURI(String s) {
        return (String)this.namespaceMap.get(s);
    }
    
    @Override
    public String getPrefix(String anObject) {
        for (Map.Entry entry : this.namespaceMap.entrySet()) {
            if (((String)entry.getValue()).equals(anObject)) {
                return (String)entry.getKey();
            }
            continue;
        }
        return null;
    }
    
    @Override
    public Iterator<String> getPrefixes(String s) {
        return this.namespaceMap.keySet().iterator();
    }
    
    private void addNamespaces(Node node) {
        if (node.getParentNode() != null) {
            this.addNamespaces(node.getParentNode());
        }
        if ((node instanceof Element)) {
            NamedNodeMap attributes = ((Node)node).getAttributes();
            for (int i = 0; i < attributes.getLength(); ++i) {
                Attr attr = (Attr)attributes.item(i);
                if ("xmlns".equals(attr.getPrefix())) {
                    this.namespaceMap.put(attr.getLocalName(), attr.getValue());
                }
            }
        }
    }
}
